// Solution pour Question 2(a)

// f et g comparent leurs paramètres en utilisant x et des sémaphores

#include <stdlib.h>
#include <assert.h>
#include <semaphore.h>
#include <stdio.h>
#include <pthread.h>

int x;
pthread_t t1,t2;

sem_t first,second;	// pour synchroniser f et g

void* f (void *arg)
{
	long int y = (long int)arg, other;

	x = y;			// f écrit son score
	sem_post(&first);	// on laisse g récupérer x
	sem_wait(&second);	// attendre que g a fini son travail
	other = x;		// on récupère le score de g

	if (other < y) printf("f gagne\n");

	return NULL;
} 

// g fait comme f, mais on échange les rôles de first et second
void* g (void *arg)
{
	long int y = (long int)arg, other;

	sem_wait(&first);	// on attend f
	other = x;		// on récupère le score de f
	x = y;			// g écrit son score
	sem_post(&second);	// on laisse f récupérer x

	if (other < y) printf("g gagne\n");

	return NULL;
} 

int main(int argc,char **argv)
{
	pthread_t t1,t2;
	assert(argc == 3);
	long int x1 = atoi(argv[1]);
	long int x2 = atoi(argv[2]);
	assert(x1 != x2);

	sem_init(&first,0,0);
	sem_init(&second,0,0);

	pthread_create(&t1,NULL,f,(void*)x1);
	pthread_create(&t2,NULL,g,(void*)x2);
	pthread_join(t1,NULL);
	pthread_join(t2,NULL);
}
